package explorviz.live_trace_processing.main;

import java.util.concurrent.TimeUnit;

import explorviz.live_trace_processing.configuration.Configuration;
import explorviz.live_trace_processing.configuration.ConfigurationFactory;
import explorviz.live_trace_processing.filter.ITraceSink;
import explorviz.live_trace_processing.filter.reconstruction.ITraceReconstruction;
import explorviz.live_trace_processing.filter.reconstruction.TraceReconstructionFilter;
import explorviz.live_trace_processing.filter.reduction.ITraceReduction;
import explorviz.live_trace_processing.filter.reduction.summarization.TracePatternSummarizationFilter;
import explorviz.live_trace_processing.reader.TCPReader;

public class FilterConfiguration {
	public static void configureAndStartFilters(final Configuration configuration,
			final ITraceSink sink) {
		// final IRecordCounting recordCounting = new
		// RecordCountingFilter(sink);

		System.out.println("tessssting");

		final ITraceReduction traceReduction = new TracePatternSummarizationFilter(
				TimeUnit.MILLISECONDS.toNanos(990), sink);

		final ITraceReconstruction traceReconstruction = new TraceReconstructionFilter(
				TimeUnit.SECONDS.toNanos(4), traceReduction);

		new TCPReader(configuration.getIntProperty(ConfigurationFactory.READER_LISTENING_PORT,
				10133), traceReconstruction).read();
	}
}
